/* Questo sketch permette di disegnare nello spazio 3D un 
parallelepipedo di dimensioni lato x lato x profondità e 
di spostarlo mediante il mouse e le frecce destra e sinistra. */

float xDes = 0; // coordinata x del parallelepipedo
float yDes = 0; // coordinata y del parallelepipedo
float lato = 100;
float profondita = -3*lato;
float zDes = 0;

void setup() 
{
  size(1000, 800, P3D);
  stroke(255);
  fill(255);
}

void draw() 
{
  if (mousePressed)
  {
    xDes = mouseX;
    yDes = mouseY;
  }
  if (keyPressed)
  {
    // movimento lungo z
    if (keyCode == LEFT)
    {
      zDes -= 10;
    }
    if (keyCode == RIGHT)
    {
      zDes += 10;
    }
  }
  background(0);
  
  translate(0,0,zDes);
  
  fill(190);
  beginShape();
    vertex(xDes, yDes,0);
    vertex(xDes+lato, yDes,0);    
    vertex(xDes+lato, yDes+lato,0);
    vertex(xDes, yDes+lato,0);    
  endShape();    

  fill(255);
  beginShape();
    vertex(xDes, yDes,0);
    vertex(xDes, yDes,profondita);    
    vertex(xDes, yDes+lato,profondita);    
    vertex(xDes, yDes+lato,0);
  endShape();    

  fill(120);
  beginShape();
    vertex(xDes, yDes,0);
    vertex(xDes, yDes,profondita);    
    vertex(xDes+lato, yDes,profondita);    
    vertex(xDes+lato, yDes,0);
  endShape();    

  fill(255);
  beginShape();
    vertex(xDes+lato, yDes,0);
    vertex(xDes+lato, yDes,profondita);    
    vertex(xDes+lato, yDes+lato,profondita);    
    vertex(xDes+lato, yDes+lato,0);
  endShape();    

  fill(120);
  beginShape();
    vertex(xDes, yDes+lato,0);
    vertex(xDes, yDes+lato,profondita);    
    vertex(xDes+lato, yDes+lato,profondita);    
    vertex(xDes+lato, yDes+lato,0);
  endShape();    

}
